<template>
  <div>
    <div v-if="statsCampaign.length > 0" class="card">
      <div class="card-header">
        <h3 class="card-title">
          Saving campaign
          <span
            style="font-weight: bold"
            v-if="campaignNameMut"
          >{{ campaignNameMut }}</span> stats
        </h3>
      </div>

      <div class="card-body">
        <p class="campaign-dates">Campaign expires in {{ moment(date).format("YYYY-MM") }}</p>
        <div class="saving-campaign-box">
          <table class="table table-hover table-striped">
            <tbody>
              <tr class="d-flex">
                <th class="col-3">Category</th>
                <th class="col-3">Spent / Wanted to spend</th>
                <th class="col-6">Progress</th>
              </tr>

              <tr class="d-flex">
                <td class="col-3">Total</td>
                <td class="col-3">
                  <span
                    class="stats-status"
                  >{{ Number(totalStats.amountSpent).toFixed(2) }} € / {{ Number(totalStats.amountWanted).toFixed(2) }} €</span>
                </td>
                <td class="col-6">
                  <b-progress
                    height="2rem"
                    :variant="String(totalStats.savingStatus)"
                    :value="totalStats.amountSpent"
                    :max="totalStats.amountWanted"
                  >
                    <b-progress-bar
                      :value="totalStats.amountSpent"
                      :class="'bg-status' + String(totalStats.savingStatus)"
                    ></b-progress-bar>
                  </b-progress>
                </td>
              </tr>
              <tr class="d-flex" v-for="cat in statsCampaign" :key="cat.id">
                <td class="col-3">{{ cat.name }}</td>
                <td class="col-3">
                  <span
                    class="stats-status"
                  >{{ cat.amountSpent.toFixed(2) }} € / {{ cat.pivot.wanted_amount }} €</span>
                </td>
                <td class="col-6">
                  <b-progress
                    height="2rem"
                    :variant="String(cat.savingStatus)"
                    :label="cat.amountSpent"
                    :value="cat.amountSpent"
                    :key="cat.id"
                    :max="cat.pivot.wanted_amount"
                  >
                    <b-progress-bar
                      :value="getProgressValue(cat.amountSpent, cat.pivot.wanted_amount)"
                      :class="'bg-status' + String(cat.savingStatus)"
                    ></b-progress-bar>
                  </b-progress>
                </td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>

      <div class="card-footer">
        <div class="saving-campaign-stats-footer">
          <div
            :class="'bg-status' + spendsDiffFromIncomeStatus"
            class="savingcampaign-stats-footer-box"
          >
            <p>{{ this.spendsDiffFromIncome }}</p>
          </div>
          <div
            :class="'bg-status' + savingAchievementsStatus"
            class="savingcampaign-stats-footer-box"
          >
            <p>{{ this.savingAchievements }}</p>
          </div>
        </div>
      </div>
      <div></div>
    </div>
  </div>
</template>

<script>
import moment from "moment";

export default {
  components: {
    moment
  },
  props: ["campaignId", "campaignName"],
  data() {
    return {
      name: "",
      date: "",
      campaignNameMut: "",
      totalStats: "",
      savingAchievements: "",
      spendsDiffFromIncome: "",
      savingAchievementsStatus: "",
      spendsDiffFromIncomeStatus: "",
      statsCampaign: {},
      active: -1,
      moment: moment
    };
  },
  methods: {
    getProgressValue(amountSpent, wantedAmount) {
      if (amountSpent > wantedAmount) {
        return 100;
      } else {
        return amountSpent;
      }
    },
    getStats() {
      this.$Progress.start();

      this.date = "";
      axios
        .get("api/saving-campaign/statistics/" + this.campaignId)
        .then(response => {
          if (response.data.found) {
            this.statsCampaign = response.data.campaignStats;
            this.totalStats = response.data.totalStats;
            this.getOverviewLabels(
              response.data.savingAchievements,
              response.data.spendsDiffFromIncome
            );
            this.active = response.data.active;
            this.campaignNameMut = response.data.name;
            this.date = response.data.date;
            this.savingAchievementsStatus =
              response.data.savingAchievementsStatus;
            this.spendsDiffFromIncomeStatus =
              response.data.spendsDiffFromIncomeStatus;
          } else {
            Fire.$emit("hideStats");
          }
          this.$Progress.finish();
        })
        .catch(error => {
          swal("Failed!", "There was something wrong.", "warning");
          this.$Progress.fail();
          console.log(error);
        });
    },

    getOverviewLabels(savingAchievements, spendsDiffFromIncome) {
      if (savingAchievements > 0) {
        this.savingAchievements =
          "You saved " +
          savingAchievements.toFixed(2) +
          " € from your saving campaign plan";
      } else {
        this.savingAchievements =
          "You lost " +
          savingAchievements.toFixed(2) * -1 +
          " € from your saving campaign plan";
      }

      if (spendsDiffFromIncome > 0) {
        this.spendsDiffFromIncome =
          "You saved " +
          spendsDiffFromIncome.toFixed(2) +
          " € compared to your income";
      } else {
        this.spendsDiffFromIncome =
          "You lost " +
          spendsDiffFromIncome.toFixed(2) * -1 +
          " € compared to your income";
      }
    }
  },

  watch: {
    campaignId: function() {
      this.getStats();
    }
  },

  created() {
    this.getStats();

    Fire.$on("loadCampaignsAndCategories", () => {
      this.getStats();
    });
  }
};
</script>
